/* Citadel/UX rnews
 * version 1.02
 *
 * This program functions the same as the standard rnews program for
 * UseNet. It accepts standard input, and looks for rooms to post messages
 * in that match the names of the newsgroups. network/rnews.xref is checked
 * in case the sysop wants to cross-reference room names to newsgroup names.
 *   The netproc program is required for final processing.
 * 
 * usage:
 *          rnews        <stdin is translated to Cit/UX format and posted>
 *          rnews -c     <assumes stdin is already in Cit/UX format and posts>
 */

#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include "citadel.h"

long lseek();
long atol();

main(argc,argv)
int argc;
char *argv[]; {
	char aaa[100],bbb[100],ccc[100];
	char author[50],recipient[50],room[50],node[50],path[300];
	long mid,now,bcount,aa;
	int a;
	char flnm[100],tname[100];
	FILE *mout,*mtemp;

	chdir(BBSDIR);
	sprintf(flnm,"./network/spoolin/rnews.%d",getpid());
	sprintf(tname,"/tmp/rnews.%d",getpid());

	mout=fopen(flnm,"w");
	if ((argc==2)&&(!strcmp(argv[1],"-c"))) {
		while ((a=getc(stdin))>=0) putc(a,mout);
		goto END;
		}
A:	a=getline(aaa,stdin);
	if (a<0) goto END;
	if (strncmp(aaa,"#! rnews ",9)) goto A;
	bcount=atol(&aaa[9]);
	mtemp=fopen(tname,"w");
	for (aa=0L; aa<bcount; ++aa) {
		a=getc(stdin);
		if (a<0) goto NMA;
		if (a>=0) putc(a,mtemp);
		}
NMA:	fclose(mtemp);
	if (a<0) goto END;

	mtemp=fopen(tname,"r");
	strcpy(author,"");
	strcpy(recipient,"");
	strcpy(room,"");
	strcpy(node,"");
	strcpy(path,"");

B:	a=getline(aaa,mtemp);
	if (a==0) goto C;
	if (a<0) goto ABORT;

	if (!strncmp(aaa,"From: ",5)) {
		while((aaa[0]!='(')&&(aaa[0]!=0)) {
			strcpy(&aaa[0],&aaa[1]);
			}
		strcpy(&aaa[0],&aaa[1]);
		for (a=0; a<strlen(aaa); ++a) if (aaa[a]==')') aaa[a]=0;
		strcpy(author,aaa);
		goto B;
		}

	if (!strncmp(aaa,"Path: ",5)) strcpy(path,&aaa[6]);

	if (!strncmp(aaa,"Newsgroups: ",11)) {
		strcpy(room,&aaa[12]);
		for (a=0; a<strlen(aaa); ++a) if (aaa[a]==',') aaa[a]=0;
		goto B;
		}

	if (!strncmp(aaa,"Message-ID: ",11)) {
		strcpy(bbb,&aaa[13]);
		for (a=0; a<strlen(bbb); ++a) if (bbb[a]=='@') bbb[a]=0;
		mid=atol(bbb);
		while((aaa[0]!='@')&&(aaa[0]!=0)) {
			strcpy(&aaa[0],&aaa[1]);
			}
		strcpy(&aaa[0],&aaa[1]);
for (a=0; a<strlen(aaa); ++a) if ((aaa[a]=='.')||(aaa[a]=='>')) aaa[a]=0;
		strcpy(node,aaa);
		goto B;
		}
		goto B;

C:	if ((author[0]==0)||(room[0]==0)||(node[0]==0)) goto ABORT;
	putc(255,mout);			/* start of message */
	putc(MES_NORMAL,mout);		/* not anonymous */
	putc(1,mout);			/* not formatted */
	time(&now);

	fprintf(mout,"I%ld",mid); putc(0,mout);
	fprintf(mout,"P%s",path); putc(0,mout);
	fprintf(mout,"T%ld",now); putc(0,mout);
	fprintf(mout,"A%s",author); putc(0,mout);
	strcpy(ccc,room);
	getroom(room,ccc);
	fprintf(mout,"O%s",room); putc(0,mout);
	fprintf(mout,"N%s",node); putc(0,mout);
	fprintf(mout,"M");
	a=0;
	aaa[0]=0;

D:	do {
		a=getc(mtemp);
		if (a>0) putc(a,mout);
		} while (a>0);
	putc(0,mout);
ABORT:	pclose(mtemp);
	unlink(tname);
	goto A;

END:	putc(0,mout);
	fclose(mout);
	unlink(tname);
	execlp("netproc","netproc",NULL);
	exit(0);
}

strucmp(st1,st2)
char st1[];
char st2[]; {
	int a;
	char aaa[100],bbb[100];
	for (a=0; a<=strlen(st1); ++a) aaa[a]=tolower(st1[a]);
	for (a=0; a<=strlen(st2); ++a) bbb[a]=tolower(st2[a]);
	a=strcmp(aaa,bbb);
	return(a);
	}

getroom(room,ngroup)		/* xref table */
char room[]; 
char ngroup[]; {
	FILE *fp;
	int a,b;
	char aaa[50],bbb[50];
	
	strcpy(room,ngroup);
	fp=fopen("network/rnews.xref","r");
GNA:	strcpy(aaa,""); strcpy(bbb,"");
	do {
		a=getc(fp);
		if (a==',') a=0;
		if (a>0) { b=strlen(aaa); aaa[b]=a; aaa[b+1]=0; }
		} while(a>0);
	do {
		a=getc(fp);
		if (a==10) a=0;
		if (a>0) { b=strlen(bbb); bbb[b]=a; bbb[b+1]=0; }
		} while(a>0);
	if (a<0) {
		fclose(fp);
		return(1);
		}
	if (strucmp(ngroup,aaa)) goto GNA;
	fclose(fp);
	strcpy(room,bbb);
	return(0);
}

getline(str,fp)
char str[];
FILE *fp; {
	int a,b;

	a=0;
	str[0]=0;
	do {
		a=getc(fp);
		if (a>10) { b=strlen(str); str[b]=a; str[b+1]=0; }
		} while(a>10);
	if (a<0) return(a);
	return(strlen(str));
	}
