/* Citadel/UX room-oriented routines */

#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <pwd.h>
#include <setjmp.h>
#include <termio.h>
#include "citadel.h"

#define IFEXPERT if (usersupp.flags&US_EXPERT)
#define IFNEXPERT if ((usersupp.flags&US_EXPERT)==0)
#define IFAIDE if (usersupp.axlevel>=6)
#define IFNAIDE if (usersupp.axlevel<6)

long atol();
long lseek();
long finduser();

extern int curr_rm;
extern int ugnum;
extern long uglsn;
extern struct quickroom quickroom;
extern struct usersupp usersupp;
extern struct fullroom fullroom;

knrooms(USgiven)
struct usersupp *USgiven;
{
	int a,b,c,d,file;
	struct quickroom QRscratch;

	b=1;
	printf("\n   Rooms with unread messages:\n");
	file=open("./quickroom",O_RDONLY); if (file<0) return(1);
	for (a=0; a<MAXROOMS; ++a) {
		c=read(file,&QRscratch,sizeof(struct quickroom));
		if (c<1) interr(58);
		if (a==1) QRscratch.QRhighest=USgiven->mailnum[MAILSLOTS-1];
		d=b+strlen(QRscratch.QRname)+3;
		if ((QRscratch.QRflags & QR_INUSE)
			&& (QRscratch.QRhighest> (USgiven->lastseen[a]) )
			&& ( (a!=2) || (USgiven->axlevel>=6))
			&& (QRscratch.QRgen != (USgiven->forget[a]) )

			&& (	((QRscratch.QRflags&QR_PREFONLY)==0)
			||	((USgiven->axlevel)>=5)
			)

			&& (	((QRscratch.QRflags&QR_PRIVATE)==0)
   			||	((USgiven->axlevel)>=6)
   			||	(QRscratch.QRgen==(USgiven->generation[a]))
   			)

		) {
		if (d>=(USgiven->screenwidth)) {
			printf("\n"); b=1; }
		c=room_prompt(&QRscratch);
		printf("%s%c  ",QRscratch.QRname,c);
		b=b+strlen(QRscratch.QRname)+3;
		}
	} 
	if (b!=1) printf("\n");

	b=1;
	printf("\n   No unseen messages in:\n");
	lseek(file,0L,0);
	for (a=0; a<MAXROOMS; ++a) {
		c=read(file,&QRscratch,sizeof(struct quickroom));
		if (c<1) return(1);
		if (a==1) QRscratch.QRhighest=USgiven->mailnum[MAILSLOTS-1];
		if ((QRscratch.QRflags & QR_INUSE)
			&& (QRscratch.QRhighest<=USgiven->lastseen[a])
			&& ( (a!=2) || ((USgiven->axlevel)>=6))
			&& (QRscratch.QRgen != USgiven->forget[a])

			&& (	((QRscratch.QRflags&QR_PREFONLY)==0)
			||	((USgiven->axlevel)>=5)
			)

			&& (	((QRscratch.QRflags&QR_PRIVATE)==0)
   			||	((USgiven->axlevel)>=6)
   			||	(QRscratch.QRgen==USgiven->generation[a])
   			)

		) {
		d=strlen(QRscratch.QRname)+3+b;
		if (d>=(USgiven->screenwidth)) {
			printf("\n"); b=1; }
		c=room_prompt(&QRscratch);
		printf("%s%c  ",QRscratch.QRname,c);
		b=b+strlen(QRscratch.QRname)+3;
		}
	}
	if (b!=1) printf("\n");

	close(file);
	return(0);
}

listzrooms(USgiven)		/* list public forgotten rooms */
struct usersupp *USgiven;
{
	int a,b,c,d,file;
	struct quickroom QRscratch;

	b=1;
	printf("\n   Forgotten public rooms:\n");
	file=open("./quickroom",O_RDONLY); if (file<0) return(1);
	for (a=0; a<MAXROOMS; ++a) {
		c=read(file,&QRscratch,sizeof(struct quickroom));
		if (c<1) interr(58);
		if (a==1) QRscratch.QRhighest=USgiven->mailnum[MAILSLOTS-1];
		if ((QRscratch.QRflags & QR_INUSE)
			&& (QRscratch.QRgen == (USgiven->forget[a]) )
			&& ( (a!=2) || ((USgiven->axlevel)>=6))
			&& (	((QRscratch.QRflags&QR_PRIVATE)==0)
   			||	((USgiven->axlevel)>=6)
   			||	(QRscratch.QRgen==(USgiven->generation[a]))
   		)
		) {
		d=b+strlen(QRscratch.QRname)+3;
		if (d>=(USgiven->screenwidth)) {
			printf("\n"); b=1; }
		c=room_prompt(&QRscratch);
		printf("%s%c  ",QRscratch.QRname,c);
		b=b+strlen(QRscratch.QRname)+3;
		}
	} 
	if (b!=1) printf("\n");
	close(file);
	return(0);
}

editroom() {	/* .<A>ide <E>dit room */
	int file,file2,a,b;
	char aaa[50]; long aa;
	struct usersupp tempUS;

	if (curr_rm<3) {
		printf("Can't edit this room.\n");
		return(0);
		}
	file=open("quickroom",O_RDWR);
	if (file<0) interr(34);
	lseek(file,(long)(curr_rm*sizeof(struct quickroom)),0);
	a=read(file,&quickroom,sizeof(struct quickroom));
	if (a<1) interr(35);
	printf("Room name is currently: %s\n",quickroom.QRname);
	printf("New name <return=same>? ");
	getline(aaa,19);
	if (aaa[0]!=0) strcpy(quickroom.QRname,aaa);
	printf("This is currently a");
	if ((quickroom.QRflags&QR_PRIVATE)==0) printf(" public");
	if (quickroom.QRflags&QR_PRIVATE) printf(" private");
	if (quickroom.QRflags&QR_PASSWORDED) printf(", passworded");
	if (quickroom.QRflags&QR_GUESSNAME) printf(", guessname");
	printf(" room");
	if ((quickroom.QRflags&QR_PASSWORDED)==QR_PASSWORDED)
			printf(", password: %s",quickroom.QRpasswd);
	printf(".\n");
if (quickroom.QRflags&QR_PREFONLY) printf("PREFERRED USERS ONLY.\n");
if (quickroom.QRflags&QR_DIRECTORY) {
	printf("Directory room");
	if (quickroom.QRflags&QR_UPLOAD) printf(", uploading allowed");
	if (quickroom.QRflags&QR_DOWNLOAD) printf(", downloading allowed");
	if (quickroom.QRflags&QR_VISDIR) printf(", visible directory");
	printf(".\nDirectory name: %s\n",quickroom.QRdirname); }
if (quickroom.QRflags&QR_ANONONLY)
	printf("Anonymous-only room.\n");

quickroom.QRflags=(quickroom.QRflags|QR_PRIVATE|QR_PASSWORDED|QR_GUESSNAME);
quickroom.QRflags=(quickroom.QRflags|QR_DIRECTORY|QR_UPLOAD|QR_DOWNLOAD);
quickroom.QRflags=(quickroom.QRflags|QR_VISDIR|QR_ANONONLY);
quickroom.QRflags=(quickroom.QRflags|QR_ANON2|QR_NETWORK|QR_PREFONLY);
	printf("New room type? <1>pub <2>guessname <3>passwd <4>inv-only : ");
	do {
		b=inkey()-48;
		} while ((b<1)||(b>4));
	printf("%d\n",b);
	if (b!=2) quickroom.QRflags=(quickroom.QRflags-QR_GUESSNAME);
	if (b!=3) quickroom.QRflags=(quickroom.QRflags-QR_PASSWORDED);
	if (b==1) quickroom.QRflags=(quickroom.QRflags-QR_PRIVATE);
	if ((quickroom.QRflags&QR_PASSWORDED)==QR_PASSWORDED) {
		printf("<return> or new password: ");
		getline(aaa,9);
		if (aaa[0]!=0) strcpy(quickroom.QRpasswd,aaa); }
	if ((quickroom.QRflags&QR_PRIVATE)==QR_PRIVATE) {
		printf("Cause users to forget room? ");
		if (yesno()==1) {	++quickroom.QRgen;
				if (quickroom.QRgen==100) quickroom.QRgen=10; }
		}

	printf("Preferred users only? ");
if (yesno()==0) quickroom.QRflags=(quickroom.QRflags-QR_PREFONLY);
	printf("Directory room? ");
if (yesno()==0) quickroom.QRflags=(quickroom.QRflags-QR_DIRECTORY);
else {
	printf("     Directory name? ");
	getline(quickroom.QRdirname,14);
	printf("  Uploading allowed? ");
if (yesno()==0) quickroom.QRflags=(quickroom.QRflags-QR_UPLOAD);
	printf("Downloading allowed? ");
if (yesno()==0) quickroom.QRflags=(quickroom.QRflags-QR_DOWNLOAD);
	printf("  Visible Directory? ");
if (yesno()==0) quickroom.QRflags=(quickroom.QRflags-QR_VISDIR); }
	printf("Network Room? ");
if (yesno()==0) quickroom.QRflags=(quickroom.QRflags-QR_NETWORK);
	printf("<1>Normal <2>Anon-only <3>Anon-option ? ");
	do {
		a=inkey()-48;
		} while((a<1)||(a>3));
	printf("%d\n",a);
if ((a==1)||(a==3)) quickroom.QRflags=(quickroom.QRflags-QR_ANONONLY);
if ((a==1)||(a==2)) quickroom.QRflags=(quickroom.QRflags-QR_ANON2);
RANSU:	file2=open("usersupp",O_RDONLY);	/* (gee, thanks a lot!) */
	if (quickroom.QRroomaide>=0L) {
		do {
			a=read(file2,&tempUS,sizeof(struct usersupp));
			} while((a>0)&&(quickroom.QRroomaide!=tempUS.eternal));
		close(file2);
		if (a>0) printf("Room aide is currently: %s\nNew ",
			tempUS.fullname);
		}
	else printf("No room aide.\n");
	printf("Room aide (RETURN to leave unchanged): ");
	getline(aaa,29);
	if (aaa[0]!=0) {
		file2=open("usersupp",O_RDONLY);
		aa=finduser(file2,aaa);
		read(file2,&tempUS,sizeof(struct usersupp));
		close(file2);
		if (aa==(-1L)) {
			printf("No such user.\n"); goto RANSU; }
		quickroom.QRroomaide=tempUS.eternal;
		}
	printf("\n\nSave changes (y/n)? ");
	if (yesno()==0) {
		lseek(file,(long)(curr_rm*sizeof(struct quickroom)),0);
		b=read(file,&quickroom,sizeof(struct quickroom));
		if (b<1) interr(36);
		close(file); return(0);
		}
	lseek(file,(long)(curr_rm*sizeof(struct quickroom)),0);
	b=write(file,&quickroom,sizeof(struct quickroom));
	close(file);
	if (quickroom.QRflags & QR_DIRECTORY) {
		sprintf(aaa,"mkdir ./files/%s",quickroom.QRdirname);
		system(aaa);
		sprintf(aaa,"./files/%s",quickroom.QRdirname);
		chmod(aaa,0777);
		}
	sprintf(aaa,"%s%c edited by %s",
		quickroom.QRname,room_prompt(&quickroom),usersupp.fullname);
	aide_message(aaa);
	return(0);
}

ungoto() {
	if (ugnum==(-1)) return(0);
	readyerself();
	curr_rm=ugnum;
	gotocurr();
	usersupp.lastseen[curr_rm]=uglsn;
	writeyerself();
	return(0);
}

download(c)
int c;
{
	int a;
	char aaa[100],bbb[100];
	if ((quickroom.QRflags&QR_DIRECTORY)
		&&(quickroom.QRflags&QR_DOWNLOAD)) {
			printf("Enter filename: ");
			getline(aaa,15);
			for (a=0; a<strlen(aaa); ++a) {
				aaa[a]=tolower(aaa[a]);
				if (aaa[a]=='/') aaa[a]='_';
				}
	sprintf(bbb,"files/%s/%s",quickroom.QRdirname,aaa);
	if (c==0) formout(bbb);
	if (c==1) {
		sprintf(aaa,"wcsend %s",bbb);
		system(aaa);
		}
	if (c==2) {
		signal(SIGQUIT,SIG_DFL);
		sttybbs(1);
		sprintf(aaa,"cat <%s",bbb);
		system(aaa);
		sttybbs(0);
		unlink("core");	/* just in case the core was dumped */
		}
	}
	else
		printf("Not in this room.\n");
	return(0);
}

roomdir() {
	char aaa[100];
	if ((quickroom.QRflags&QR_DIRECTORY)
	   &&(quickroom.QRflags&QR_VISDIR)) {
		sprintf(aaa,"./files/%s",quickroom.QRdirname);
		printf("Directory of %s!%s/%s\n",NODENAME,BBSDIR,&aaa[2]);
		directory(aaa);
		}
	else
		printf("Not in this room.\n");
	return(0);
}

invite() {	/* add a user to a private room */
	char aaa[31];
	int file;
	long aa;
	struct usersupp USscratch;
	if ((quickroom.QRflags&QR_PRIVATE)==0) {
		printf("Not a private room.\n");
		return(0);
		}
	printf("Name of user? ");
	getline(aaa,30);
	if (aaa[0]==0) return(0);
	file=open("usersupp",O_RDWR);
	if (file<0) interr(38);
	aa=finduser(file,aaa);
	if (aa!=(-1L)) {
		read(file,&USscratch,sizeof(struct usersupp));
		lseek(file,aa,0);
		USscratch.generation[curr_rm]=quickroom.QRgen;
		USscratch.forget[curr_rm]=(-1);
		write(file,&USscratch,sizeof(struct usersupp));
		}
	else	printf("No such user.\n");
	close(file);
	return(0);

}

kickout() {	/* kick a user out of a private room */
	int file;
	char aaa[100];
	long aa;
	struct usersupp USscratch;
	if ((quickroom.QRflags&QR_PRIVATE)==0) {
		printf("Not a private room.\n");
		return(0);
		}
	printf("Name of user? ");
	getline(aaa,30);
	file=open("usersupp",O_RDWR);
	if (file<0) interr(40);
	aa=finduser(file,aaa);
	if (aa!=(-1L)) {
		read(file,&USscratch,sizeof(struct usersupp));
		lseek(file,aa,0);
		USscratch.generation[curr_rm]=(-1);
		write(file,&USscratch,sizeof(struct usersupp));
		}
	else	printf("No such user.\n");
	close(file);
	return(0);
}

killroom() {	/* aide command: kill the current room */
	int file;
	long aa;
	char aaa[100];
	if (curr_rm<3) { printf("Can't kill this room.\n"); return(0); }
	printf("Are you sure you want to kill this room? ");
	if (yesno()==0) return(0);
	file=open("quickroom",O_RDWR); if (file<0) interr(42);
	aa=(long)curr_rm*sizeof(struct quickroom);
	lseek(file,aa,0);
	quickroom.QRflags=0;
	write(file,&quickroom,sizeof(struct quickroom));
	close(file);
	sprintf(aaa,"%s%c killed by %s",
		quickroom.QRname,room_prompt(&quickroom),usersupp.fullname);
	aide_message(aaa);
	curr_rm=0;		/* then goto the lobby */
	gotocurr();
	return(0);
}

forget() {	/* forget the current room */
	if (curr_rm<3) {
		printf("Cannot forget this room.\n");
		return(0);
		}
	IFAIDE { printf("Aides cannot forget rooms.\n"); return(0); }
	printf("Are you sure you want to forget this room? ");
	if (yesno()==0) return(0);
	readyerself();
	usersupp.forget[curr_rm]=quickroom.QRgen;
	usersupp.generation[curr_rm]=(-1);
	writeyerself();
	curr_rm=0;		/* then goto the lobby */
	gotocurr();
	return(0);
}

entroom() {
	int a,b,c,d,file;
	char aaa[100],bbb[100];
	long bb,cc,dd;
	struct quickroom QRscratch;

	if (usersupp.axlevel<3) {
		printf("You need higher access to create rooms.\n");
		return(0);
		}

	printf("Name for new room? ");
	getline(aaa,19);
	if (strlen(aaa)==0) return(0);
	aaa[19]=0;
	file=open("quickroom",O_RDONLY); if (file<0) interr(62);
	b=0;
	for (a=0; a<MAXROOMS; ++a) {
		c=read(file,&QRscratch,sizeof(struct quickroom));
		if (c<1) interr(63);
		if ( (QRscratch.QRflags & QR_INUSE)
			&& (!strucmp(QRscratch.QRname,aaa)) ) b=1; }
	close(file);
	if (b==1) {
		printf("'%s' already exists.\n",aaa);
		return(0); }
	bb=(-1L);	
	file=open("quickroom",O_RDONLY); if (file<0) interr(64);
	for (a=0; a<MAXROOMS; ++a) {
		cc=lseek(file,0L,1);
		c=read(file,&QRscratch,sizeof(struct quickroom));
		if (c<1) interr(65);
		if (((QRscratch.QRflags&QR_INUSE)==0)&&(bb==(-1L))) bb=cc;
		}
	close(file);
	if (bb==(-1L)) {
		printf("No room space available.\n");
		return(0);
		}
	IFNEXPERT formout("messages/roomaccess");
ACSEL:	printf("<?>Help\n<1>Public room\n<2>Guess-name room\n");
	printf("<3>Passworded room\n<4>Invitation-only room\n");
	printf("Enter room type: ");
ACSE2:	b=inkey(); b=tolower(b);
	if (b=='?') { printf("?\n");
		formout("messages/roomaccess"); goto ACSEL; }
	b=b-48;
	if ((b<1)||(b>4)) goto ACSE2;
	if (b==3) {
		printf("Enter a room password: ");
		getline(bbb,9); }
	printf("%d\n\042%s\042, a",b,aaa);
	if (b==1) printf(" public room.");
	if (b==2) printf(" guess-name room.");
	if (b==3) printf(" passworded room, password: %s",bbb);
	if (b==4) printf("n invitation-only room.");
	printf("\nInstall it? (y/n) : ");
	a=yesno();
	if (a==0) return(0);
	curr_rm=(int)(bb/sizeof(struct quickroom)); 
	file=open("quickroom",O_RDWR);
	if (file<0) interr(66);
	dd=lseek(file,bb,0);
	d=read(file,&quickroom,sizeof(struct quickroom));
	if (d<1) interr(67);
	strcpy(quickroom.QRname,aaa);
	strcpy(quickroom.QRpasswd,"");
	if (b==3) strcpy(quickroom.QRpasswd,bbb);
	quickroom.QRroomaide=(-1L);
	quickroom.QRhighest=0L;
	++quickroom.QRgen; if (quickroom.QRgen==100) quickroom.QRgen=10;
	quickroom.QRflags=QR_INUSE;
	if (b>1) quickroom.QRflags=(quickroom.QRflags|QR_PRIVATE);
	if (b==2) quickroom.QRflags=(quickroom.QRflags|QR_GUESSNAME);
	if (b==3) quickroom.QRflags=(quickroom.QRflags|QR_PASSWORDED);
	if ((b>2)&&(CREATAIDE==1)) quickroom.QRroomaide=usersupp.eternal;
	lseek(file,bb,0);
	write(file,&quickroom,sizeof(struct quickroom));
	close(file);

	/* Initialize a blank fullroom structure */
	for (a=0; a<MSGSPERRM; ++a) {
		fullroom.FRnum[a]=0L;
		fullroom.FRpos[a]=0L;
		}

	sprintf(aaa,"./rooms/fullrm%d",curr_rm);
	file=open(aaa,O_RDWR);
	if (file<0) interr(70);
	write(file,&fullroom,sizeof(struct fullroom));
	close(file);
	gotocurr();
	strcpy(aaa,quickroom.QRname); strcat(aaa,"> created by ");
	strcat(aaa,usersupp.fullname);
	if (quickroom.QRflags&QR_PRIVATE) strcat(aaa," [private]");
	if (quickroom.QRflags&QR_GUESSNAME) strcat(aaa,"[guessname] ");
	if (quickroom.QRflags&QR_PASSWORDED) {
		strcat(aaa,"\n Password: ");
		strcat(aaa,quickroom.QRpasswd);
		}
	aide_message(aaa);
	return(0);
}

gotocurr() /* goto room currently in global variable curr_rm */
{
	int file,d; char aaa[100];
	file=open("quickroom",O_RDONLY); if (file<0) interr(74);
		lseek(file,(long)(curr_rm*sizeof(struct quickroom)),0);
		d=read(file,&quickroom,sizeof(struct quickroom));
		if (d<1) interr(75);
	close(file);
	if (curr_rm==1) { readmail(); return(0); }
	sprintf(aaa,"./rooms/fullrm%d",curr_rm);
	file=open(aaa,O_RDONLY); if (file<0) interr(76);
	d=read(file,&fullroom,sizeof(struct fullroom));
	if (d<1) interr(77);
	close(file);
	return(0);
}

whoknows() {
	struct usersupp temp;
	int file;
	file=open("usersupp",O_RDONLY);
	if (file<0) return(file);
	while(read(file,&temp,sizeof(struct usersupp))>0)
		if ((quickroom.QRflags & QR_INUSE)
			&& ( (curr_rm!=2) || (temp.axlevel>=6) )
			&& (quickroom.QRgen != (temp.forget[curr_rm]) )

			&& (	((quickroom.QRflags&QR_PREFONLY)==0)
			||	(temp.axlevel>=5)
			)

			&& (	((quickroom.QRflags&QR_PRIVATE)==0)
   			||	(temp.axlevel>=6)
   			||	(quickroom.QRgen==(temp.generation[curr_rm]))
   			)

		) printf("%s\n",temp.fullname);
	close(file);
	return(0);
}
