/* Citadel/UX independent routines (i.e. no global variables are used) */

#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <pwd.h>
#include <setjmp.h>
#include <termio.h>

#define ROUTINES_C

#include "citadel.h"

#define IFEXPERT if (usersupp.flags&US_EXPERT)
#define IFNEXPERT if ((usersupp.flags&US_EXPERT)==0)
#define IFUPASS if (upass!=0)
#define IFNUPASS if (upass==0)
#define IFAIDE if(usersupp.axlevel>=6)
#define IFNAIDE if (usersupp.axlevel<6)
struct passwd *getpwuid();
struct passwd *getpwnam();
char *getenv();
long atol();
long lseek();

extern char *days[7];
extern char *months[12];
extern char *axdefs[7];

strucmp(st1,st2) /* Compares two strings without case sensitivity */
char st1[],st2[]; {
char aaa[100],bbb[100];
int a;
	for (a=0; a<=strlen(st1); ++a) aaa[a]=tolower(st1[a]);
	for (a=0; a<=strlen(st2); ++a) bbb[a]=tolower(st2[a]);
	return(strcmp(aaa,bbb));
}

back(spaces) /* Destructive backspace */
int spaces; {
int a;
	for (a=1; a<=spaces; ++a) {
		putc(8,stdout); putc(32,stdout); putc(8,stdout);
		}
	}

yesno() { /* Returns 1 for yes, 0 for no */
int a;
	while (1) {
		a=inkey(); a=tolower(a);
		if (a=='y') { printf("Yes\n"); return(1); }
		if (a=='n') { printf("No\n");  return(0); }
		}
	}

edituser(structure)
struct usersupp *structure; {
	int a,b;
do {	printf("Current access level: %d [%s]\n",structure->axlevel,
		axdefs[structure->axlevel]);
	printf("New level (? to list them): ");
	a=inkey();
	if (a=='?') {
		printf("list\n");
		for (b=0; b<7; ++b) printf("%d %s\n",b,axdefs[b]);
		}
	a=a-48;
	} while((a<0)||(a>6));
	printf("%d\n",a);
	structure->axlevel=a;
	return(0);
	}

getusinfo(structure)
struct usersupp *structure; {
	int a; char aaa[100];
	do {
		printf("Enter your screen width: ");
		getline(aaa,3); a=atoi(aaa);
		if ((a<20)||(a>132))
			printf("...must be between 20 and 132.\n");
		} while((a<20)||(a>132));
	structure->screenwidth=a;
	printf("Are you an experienced Citadel user? ");
	structure->flags=((structure->flags)|US_EXPERT);
	if (yesno()==0) structure->flags=((structure->flags)^US_EXPERT);
	printf("Print last old message on New message request? ");
	structure->flags=((structure->flags)|US_LASTOLD);
	if (yesno()==0) structure->flags=((structure->flags)^US_LASTOLD);
	if ((structure->flags&US_EXPERT)==0) formout("messages/unlisted");
	printf("List in userlog? ");
	structure->flags=((structure->flags)|US_UNLISTED);
	if (yesno()==1) structure->flags=((structure->flags)^US_UNLISTED);
	printf("Prompt after each message? ");
	structure->flags=((structure->flags)|US_NOPROMPT);
	if (yesno()==1) structure->flags=((structure->flags)^US_NOPROMPT);
}

getfield(file,string)		/* Break out next null-terminated string */
int file; char string[]; {
int a,b,c;
	strcpy(string,"");
	a=0;
	do {
		c=0; b=read(file,&c,1);
		if (b<1) { string[a]=0; return(0); }
		string[a]=c;
		++a;
		} while(c!=0); return(0);
}

getstring(file,string)		/* get a line of text from a file */
int file; char string[]; {	/* ignores lines beginning with # */
int a,b,c;
do {
	strcpy(string,"");
	a=0;
	do {
		c=0; b=read(file,&c,1);
		if (b<1) { string[a]=0; return(-1); }
		string[a]=c;
		++a;
		} while(c!=10);
		string[a-1]=0;
	} while(string[0]=='#');
return(strlen(string));
}

pattern(search,patn)	/* Searches for patn in search string */
char search[];
char patn[];
{
	int a,b;
	for (a=0; a<strlen(search); ++a)
	{	b=strncmp(&search[a],patn,strlen(patn));
		if (b==0) return(b);
		}
	return(1);
}

interr(errnum)	/* display internal error as defined in errmsgs */
int errnum; {
	printf("INTERNAL ERROR %d\n",errnum);
	printf("(Press any key to continue)\n");
	inkey();
	logoff(errnum);
}

directory(path)
char *path;
{
	struct directx {
		int d_ino;
		char d_name[15];
	} dlink;
	char comment[151];
	int fd,nread,a; char tname[100];
	struct stat statbuf; long aa;
	FILE *fp;
if ((fd=open(path,0))==(-1)) return(1);
dlink.d_name[14]=0;
printf("-----------------------\n");
read(fd,&dlink,16); read(fd,&dlink,16);
while ((nread=read(fd,&dlink,16)) > 0)
	{
	if ((strucmp(dlink.d_name,"filedir"))&&(dlink.d_ino!=0)) {
		sprintf(tname,"%s/%s",path,dlink.d_name);
		stat(tname,&statbuf);
		aa=(long)statbuf.st_size;
		sprintf(tname,"%s/filedir",path);
	fp=fopen(tname,"r");
	comment[0]=0;
	if (fp!=NULL) {
		do {
			for (a=0; a<17; ++a) comment[a]=0;
			fgets(comment,151,fp);
			comment[strlen(comment)-1]=0;
	if (!strncmp(comment,dlink.d_name,strlen(dlink.d_name))) goto FND;
			} while(!feof(fp));
FND:		fclose(fp);
		}
printf("%-14s %8ld %s\n",dlink.d_name,aa,&comment[strlen(dlink.d_name)+1]);
	}
	}
	close(fd);
	return(0);
}

fpgetfield(fp,string)	/* level-2 break out next null-terminated string */
FILE *fp;
char string[];
{
int a,b;
strcpy(string,"");
a=0;
	do {
		b=getc(fp);
		if (b<1) { string[a]=0; return(0); }
		string[a]=b;
		++a;
		} while(b!=0);
	return(0);
}


fmout(width,flname)
int width;
char flname[];
	{

	int a,b,c,real,old;
	char aaa[140];
	FILE *fp;
	
	fp=fopen(flname,"rb");
	if (fp==NULL) {
			printf("No file %s.\n",flname);
			return(1); }

	strcpy(aaa,""); old=255;
	c=1; /* c is the current pos */
FMTA:	old=real; a=getc(fp); real=a;
	if (a==0) goto FMTEND;
	if (a<0) goto FMTEND;
	
	if ( ((a==13)||(a==10)) && (old!=13) && (old!=10) ) a=32;
	if ( ((old==13)||(old==10)) && (isspace(real)) ) {
						printf("\n"); c=1; }
	if (a>126) goto FMTA;

	if (a>32) {
	if ( ((strlen(aaa)+c)>(width-5)) && (strlen(aaa)>(width-5)) )
		{ printf("\n%s",aaa); c=strlen(aaa); aaa[0]=0; }
	 b=strlen(aaa); aaa[b]=a; aaa[b+1]=0; }
	if (a==32) { 	if ((strlen(aaa)+c)>(width-5)) { 
							printf("\n");
							c=1;
							}
			printf("%s ",aaa); ++c; c=c+strlen(aaa);
			strcpy(aaa,""); goto FMTA; }
	if ((a==13)||(a==10)) {
				printf("%s\n",aaa); c=1;
				strcpy(aaa,""); goto FMTA; }
	goto FMTA;

FMTEND:	fclose(fp);
	printf("\n");
	return(0);
}

strproc(string)
char string[];
{
	int a;
	char aaa[100];
	char bbb[5];
	strcpy(aaa,string);

	if (string[0]==0) return(0);

/* Convert non-printable characters to blanks */
	for (a=0; a<strlen(aaa); ++a) {
		if (aaa[a]<32) aaa[a]=32;
		if (aaa[a]>126) aaa[a]=32; }

/* Remove leading and trailing blanks */
	while(aaa[0]<33) strcpy(aaa,&aaa[1]);
	while(aaa[strlen(aaa)-1]<33) aaa[strlen(aaa)-1]=0;

/* Remove double blanks */
	bbb[1]=0;
	strcpy(string,"");
	for (a=0; a<strlen(aaa); ++a) {
		if ((aaa[a]==32)&&(aaa[a+1]==32)) goto PSSKP;
	bbb[0]=aaa[a];
	strcat(string,bbb);
PSSKP:	bbb[1]=0;
	}

/* remove characters which would interfere with the network */
	for (a=0; a<strlen(aaa); ++a) {
		if (aaa[a]=='!') strcpy(&aaa[a],&aaa[a+1]);
		if (aaa[a]=='@') strcpy(&aaa[a],&aaa[a+1]);
		if (aaa[a]=='_') strcpy(&aaa[a],&aaa[a+1]);
		if (aaa[a]==',') strcpy(&aaa[a],&aaa[a+1]);
		}

	return(0);
}

sttybbs(sflag) 
int sflag;{
struct termio live;
	ioctl(0,TCGETA,&live);
	live.c_iflag=ISTRIP|IXON|IXANY;
	live.c_oflag=OPOST|ONLCR;
	live.c_lflag=NOFLSH;
	if (sflag==1) live.c_lflag=ISIG|NOFLSH;
	live.c_line=0;
	live.c_cc[0]=15;
	live.c_cc[1]=3;
	live.c_cc[2]=8;
	live.c_cc[3]=24;
	live.c_cc[4]=1;
	live.c_cc[5]=255;
	live.c_cc[6]=0;
	live.c_cc[7]=0;
	ioctl(0,TCSETA,&live);
	return(0);
}

long finduser(file,name)	/* binary search for a user */
int file;
char name[];
{
	struct usersupp temp;
	int a;
	long bottom,top,guess,obottom,otop;

	obottom=(-1L); otop=(-1L);
	bottom=0L;
	top=(lseek(file,0L,2)/(long)sizeof(struct usersupp));

while(1) {
	if ((obottom==bottom)&&(otop==top)) return(-1L);
	obottom=bottom; otop=top;
	guess=(((top-bottom)/2)+bottom);
	lseek(file,(guess*(long)sizeof(struct usersupp)),0);
	read(file,&temp,sizeof(struct usersupp));
	a=strucmp(temp.fullname,name);
	if (a==0) return(lseek(file,(guess*(long)sizeof(struct usersupp)),0));
	if (a<0) bottom=guess;
	if (a>0) top=guess;
	}
}

rec_log(record)		/* record an entry in the call log */
struct calllog *record;
{
	int file,a,b;
	time(&record->CLtime);
	file=open("calllog.pos",O_RDWR);
	read(file,&a,2);
	b=a; ++a; if (a==CALLLOG) a=0;
	lseek(file,0L,0);
	write(file,&a,2);
	close(file);

	file=open("calllog",O_RDWR);
	lseek(file,(long)(b*sizeof(struct calllog)),0);
	write(file,record,sizeof(struct calllog));
	close(file);
	return(0);
}

log_carr()		/* use rec_log to record the connection */
{
	struct calllog temp;
	struct termio stty;
	strcpy(temp.CLfullname,ttyname(0));
	temp.CLflags=CL_INOTHER;
	ioctl(0,TCGETA,&stty);
	if ((stty.c_cflag&B300)==B300)		temp.CLflags=CL_IN300;
	if ((stty.c_cflag&B1200)==B1200)	temp.CLflags=CL_IN1200;
	if ((stty.c_cflag&B2400)==B2400)	temp.CLflags=CL_IN2400;
	if ((stty.c_cflag&B9600)==B9600)	temp.CLflags=CL_INOTHER;
	rec_log(&temp);
	return(0);
}

alias(name)		/* process alias and routing info for mail */
char name[]; {
	FILE *fp;
	int a,b,file;
	char aaa[300],bbb[300];
	
	fp=fopen("network/mail.aliases","r");
	if (fp==NULL) return(2);
GNA:	strcpy(aaa,""); strcpy(bbb,"");
	do {
		a=getc(fp);
		if (a==',') a=0;
		if (a>0) { b=strlen(aaa); aaa[b]=a; aaa[b+1]=0; }
		} while(a>0);
	do {
		a=getc(fp);
		if (a==10) a=0;
		if (a>0) { b=strlen(bbb); bbb[b]=a; bbb[b+1]=0; }
		} while(a>0);
	if (a<0) {
		fclose(fp);
		goto DETYPE;
		}
	if (strucmp(name,aaa)) goto GNA;
	fclose(fp);
	strcpy(name,bbb);
	printf("*** Mail is being forwarded to %s\n",name);

DETYPE:	/* determine local or remote type, see citadel.h */
	for (a=0; a<strlen(name); ++a) if (name[a]=='!') return(M_UUCP);
	b=0; for (a=0; a<strlen(name); ++a) if (name[a]=='@') ++b;
	if (b>1) {
		printf("Too many @'s in address\n");
		return(M_ERROR);
		}
	if (b==1) {
		for (a=0; a<strlen(name); ++a)
			if (name[a]=='@') strcpy(bbb,&name[a+1]);
		while (bbb[0]==32) strcpy(bbb,&bbb[1]);
		file=open("network/mail.sysinfo",O_RDONLY);
GETSN:		do {
			a=getstring(file,aaa);
			} while ((a>=0)&&(strucmp(aaa,bbb)));
		a=getstring(file,aaa);
		if (!strncmp(aaa,"use ",4)) {
			strcpy(bbb,&aaa[4]);
			goto GETSN;
			}
		close(file);
		if (!strncmp(aaa,"bin",3)) {
			strcpy(aaa,name); strcpy(bbb,name);
			while (aaa[strlen(aaa)-1]!='@') aaa[strlen(aaa)-1]=0;
			aaa[strlen(aaa)-1]=0;
			while (aaa[strlen(aaa)-1]==' ') aaa[strlen(aaa)-1]=0;
			while (bbb[0]!='@') strcpy(bbb,&bbb[1]);
			strcpy(bbb,&bbb[1]);
			while (bbb[0]==' ') strcpy(bbb,&bbb[1]);
			sprintf(name,"%s @%s",aaa,bbb);
			return(M_BINARY);
			}
		printf("Error in network/mail.sysinfo file\n");
		return(M_ERROR);
		}
	return(M_LOCAL);
	}
