/* More Citadel/UX routines...
 * unlike routines.c, some of these DO use global variables.
 */

#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <pwd.h>
#include <setjmp.h>
#include <termio.h>
#include "citadel.h"

long atol();
long lseek();
long finduser();

extern int curr_rm;
extern int ugnum;
extern long uglsn;
extern struct quickroom quickroom;
extern struct usersupp usersupp;
extern struct fullroom fullroom;
extern char temp[];
extern char *axdefs[7];

eopen(name,mode)
char *name;
int mode; {
	int ret;
	ret=open(name,mode);
	if (ret<0) {
		fprintf(stderr,"-------------------------\n");
		fprintf(stderr,"Cannot open file '%s', mode=%d\n",name,mode);
		interr(1);
		}
	return(ret);
	}

pwcrypt(text,code)
char text[];
int code; {
	int a;
	for (a=0; a<strlen(text); ++a) text[a]=(text[a]^(((code|128)^a)&0xFF));
	return(0);
	}

int room_prompt(qrptr)	/* return proper room prompt character */
struct quickroom *qrptr; {
	int a;
a='>'; if ((qrptr->QRflags)&QR_DIRECTORY) a=']';
if ((a==']')&&((qrptr->QRflags)&QR_NETWORK)) a='}';
	if ((a=='>')&&((qrptr->QRflags)&QR_NETWORK)) a=')';
	return(a);
	}

entregis(who)		/* register a user with name and address */
long who; {
	int f,file,a,b;
	char pbuf[15];
	struct registration regis,rtemp;
	regis.RGeternal=who;
	printf("REAL name: ");
	getline(regis.RGname,29);
	printf("  Address: ");
	getline(regis.RGaddr,24);
	printf("City/town: ");
	getline(regis.RGcity,14);
	printf("    State: ");
	getline(regis.RGstate,2);
	printf(" ZIP code: ");
	getline(regis.RGzip,5);
	printf("Phone num: ");
	getline(pbuf,14);
	regis.RGphone[0]=0;
	for (a=0; a<strlen(pbuf); ++a) 
		if ((pbuf[a]>='0')&&(pbuf[a]<='9')) {
			b=strlen(regis.RGphone);
			regis.RGphone[b]=pbuf[a]; regis.RGphone[b+1]=0;
			}
	printf("\n");
	f=fork();			/* register in the background */
	if (f<0) {
		fprintf(stderr,"citadel: cannot fork-registration not filed\n");
		return(-1);
		}
	if (f>0) return(0);
	
	/* remainder of this routine happens in a separate task! */
	file=open("registration",O_RDWR);
	if (file<0) file=creat("registration",0644);
	while(read(file,&rtemp,sizeof(struct registration))>0) {
		if (rtemp.RGeternal==who) {
			lseek(file,(0L-sizeof(struct registration)),1);
			goto WRT;
			}
		}
WRT:	write(file,&regis,sizeof(struct registration));
	close(file);
	exit(0);		/* no, not return() - we're a child process */
	}


updatels() {	/* make all messages old in current room */
	int a;
	readyerself();
	storeug();
	for (a=0; a<MSGSPERRM; ++a)
		if (fullroom.FRnum[a]>usersupp.lastseen[curr_rm])
			usersupp.lastseen[curr_rm]=fullroom.FRnum[a];
	if (curr_rm==1) /* if mail room, do it a little differently... */
		usersupp.lastseen[1]=usersupp.mailnum[MAILSLOTS-1];
	writeyerself();
}

storeug() {	/* store <u>ngoto information */
	ugnum=curr_rm;
	uglsn=usersupp.lastseen[curr_rm];
	return(0); }


getline(string,lim)	/* Gets a line from the terminal */
char string[]; 		/* Pointer to string buffer */
int lim;		/* Maximum length - if negative, no-show */
{
int a,b; char flag;
	flag=0;
	if (lim<0) { lim=(0-lim); flag=1; }
	strcpy(string,"");
GLA:	a=inkey(); a=(a&127);
	if ((a==8)&&(strlen(string)==0)) goto GLA;
	if ((a!=13)&&(a!=8)&&(strlen(string)==lim)) goto GLA;
	if ((a==8)&&(string[0]!=0)) {
		string[strlen(string)-1]=0;
		putc(8,stdout); putc(32,stdout); putc(8,stdout); goto GLA; }
	if ((a==13)||(a==10)) {
		putc(13,stdout); putc(10,stdout); return(0); }
	b=strlen(string);
	string[b]=a;
	string[b+1]=0;
	if (flag==0) putc(a,stdout);
	if (flag==1) putc('*',stdout);
	goto GLA;
}

delete_message(delnum) /* Delete message from current room */
long delnum; {
	int file,a,b;
	char aaa[100];
	if (curr_rm==1) {
		printf("Can't delete mail.\n");
		return(1); }
	sprintf(aaa,"./rooms/fullrm%d",curr_rm);
	file=eopen(aaa,O_RDWR);
	a=read(file,&fullroom,sizeof(struct fullroom));
	if (a<1) interr(79); 
	for (a=0; a<MSGSPERRM; ++a)
		if (fullroom.FRnum[a]==delnum) {
			fullroom.FRnum[a]=0L;
			fullroom.FRpos[a]=0L; }
	lseek(file,0L,0);
	a=write(file,&fullroom,sizeof(struct fullroom));
	if (a<1) interr(80);
	close(file);
	file=eopen("./quickroom",O_RDWR);
	lseek(file,(long)(curr_rm*sizeof(struct quickroom)),0);
	b=read(file,&quickroom,sizeof(struct quickroom));
	if (b<1) interr(82);
	quickroom.QRhighest=0L;
	for (a=0; a<MSGSPERRM; ++a)
		if (fullroom.FRnum[a]>quickroom.QRhighest)
			quickroom.QRhighest=fullroom.FRnum[a];
	lseek(file,(long)(curr_rm*sizeof(struct quickroom)),0);
	b=write(file,&quickroom,sizeof(struct quickroom));
	if (b<1) interr(83);
	close(file);
	printf("Message deleted.\n");
	return(0);
}


upload(c)	/* c = upload mode */
int c; {
	char buf[151],aaa[100],bbb[60],ccc[60];
	int a,b,file;
	long cc;
	FILE *fp;

	if ( ((quickroom.QRflags&QR_DIRECTORY)==0)
		|| ((quickroom.QRflags&QR_UPLOAD)==0) ) {
			printf("Not in this room.\n");
			return(1);
			}

	printf("Enter filename: ");
	getline(aaa,15);
	for (a=0; a<strlen(aaa); ++a) aaa[a]=tolower(aaa[a]);
	sprintf(bbb,"./files/%s/%s",quickroom.QRdirname,aaa);
	file=open(bbb,O_RDONLY);
	if (file>(-1)) {
		printf("There already is a file by that name.\n");
		close(file); return(1); }
	printf("Enter a short description of the file:\n: ");
	getline(buf,150);
	sprintf(ccc,"./files/%s/filedir",quickroom.QRdirname);
	fp=fopen(ccc,"r+");
	if (fp==NULL) fp=fopen(ccc,"w");
	fseek(fp,0L,2);
	fprintf(fp,"%s %s\n",aaa,buf);
	fclose(fp);
	file=creat(bbb,0666);
	if (file<0) {
		printf("Can't create that file?\n");
		return(1); }
	if (c>0) {
		close(file);
		goto ETUX;
		}
	a=0;
	printf("Now recieving. ESC to end.\n");
	do {
		b=inkey(); 
		if (b==13) { b=10; printf("\r"); }
		if (b!=27) { printf("%c",b); write(file,&b,1); }
		} while(b!=27);
	close(file);
ETPRF:	printf("File recieved.\n");
	time(&cc);			/* put together an upload notice */
	fp=fopen(temp,"wb"); if (fp==NULL) interr(22);
	putc(255,fp);
	putc(MES_NORMAL,fp);
	putc(0,fp);
	fprintf(fp,"Psysop"); putc(0,fp);
	fprintf(fp,"T%ld",cc); putc(0,fp);
	fprintf(fp,"A%s",usersupp.fullname); putc(0,fp);
	fprintf(fp,"O%s",quickroom.QRname); putc(0,fp);
	fprintf(fp,"N%s",NODENAME); putc(0,fp); putc('M',fp);
	fprintf(fp,"*New Upload*\nFilename: %s\r %s\n",aaa,buf);
	putc(0,fp);
	fclose(fp);
	save_message(temp,buf,0,M_LOCAL);
	return(0);

ETUX:	if (c==1) {
		sprintf(ccc,"wcreceive %s",bbb);
		system(ccc);
		}
	goto ETPRF;
}

move_message(pos)
long pos; {
	char targ[20];
	int file,a,h;
	struct quickroom qtemp;
	h=curr_rm;
	pull_message(pos,temp);
	do {
		curr_rm=(-1);
		printf("Enter target room: ");
		getline(targ,19);
		if (targ[0]==0) strcpy(targ,quickroom.QRname);
		file=open("quickroom",O_RDONLY);
		for (a=0; a<MAXROOMS; ++a) {
			read(file,&qtemp,sizeof(struct quickroom));
if ((!strucmp(qtemp.QRname,targ))&&(qtemp.QRflags&QR_INUSE)) curr_rm=a;
			}
		close(file);
		} while(curr_rm<0);
	gotocurr();
	save_message(temp,"",0,M_LOCAL);
	curr_rm=h;
	gotocurr();
	return(0);
	}

aide_message(text) 			/* post a message in Aide> */
char *text; {
	long now;
	FILE *fp;

	time(&now);
	fp=fopen(temp,"wb"); if (fp==NULL) interr(92);
	putc(255,fp);
	putc(MES_NORMAL,fp);
	putc(0,fp);
	fprintf(fp,"Psysop"); putc(0,fp);
	fprintf(fp,"T%ld",now); putc(0,fp);
	fprintf(fp,"ACitadel"); putc(0,fp);
	fprintf(fp,"OAide"); putc(0,fp);
	fprintf(fp,"N%s",NODENAME); putc(0,fp); putc('M',fp);
	fprintf(fp,"%s\n",text);
	putc(0,fp);
	fclose(fp);
	save_message(temp,"",1,M_LOCAL);
	return(0);
	}

validate() {	/* validate new users */
	struct msgmain MMtemp;
	struct usersupp UStemp;
	int file,a,b;

	file=eopen("MMstructure",O_RDONLY);
	read(file,&MMtemp,sizeof(struct msgmain));
	close(file);
	if ((MMtemp.MMflags&MM_VALID)==0) {
		printf("There are no unvalidated users.\n");
		return(0);
		}
	do {
		file=eopen("MMstructure",O_RDONLY);
		read(file,&MMtemp,sizeof(struct msgmain));
		close(file);
		} while(MMtemp.MMflags&MM_BUSY);
	file=eopen("MMstructure",O_WRONLY);
	MMtemp.MMflags=MMtemp.MMflags&(~MM_VALID);
	write(file,&MMtemp,sizeof(struct msgmain));
	close(file);

	file=eopen("usersupp",O_RDWR);
	while(read(file,&UStemp,sizeof(struct usersupp))>0) {
		if (UStemp.axlevel==1) {
			printf("\n\n\nUser #%-5ld %s ",
			       UStemp.eternal,UStemp.fullname);
			if (usersupp.screenwidth<=40) printf("\n");
			pwcrypt(UStemp.password,PWCRYPT);
			printf("PW: %s\n",UStemp.password);
			dis_regis(&UStemp);
			printf("Access level (? for list): ");
			do {
				a=inkey();
				if (a=='?') {
					printf("list\n");
					for (b=0; b<7; ++b)
						printf("%d %s\n",b,axdefs[b]);
					}
				a=a-48;
				} while((a<0)||(a>6));
			printf("%d\n",a);
			UStemp.axlevel=a;
			pwcrypt(UStemp.password,PWCRYPT);
			lseek(file,(0L-sizeof(struct usersupp)),1);
			write(file,&UStemp,sizeof(struct usersupp));
			}
		}
	close(file);
	printf("\n*** End of registration.\n");
	return(0);
	}

dis_regis(userdata)
struct usersupp *userdata; {
	struct registration regis;
	int a,b,file;
	char pbuf[20];
	if (!((userdata->flags)&US_REGIS)) {
		printf("No registration online.\n");
		return(1);
		}
	file=open("registration",O_RDONLY);
	if (file<0) return(2);
	while(read(file,&regis,sizeof(struct registration))>0) {
		if (userdata->eternal==regis.RGeternal) {
			printf("%-29s\n",regis.RGname);
			printf("%-29s\n",regis.RGaddr);
			printf("%-14s %2s %6s\n",
				regis.RGcity,regis.RGstate,regis.RGzip);
			strcpy(pbuf,regis.RGphone);
			regis.RGphone[0]=0;
			for (a=0; a<strlen(pbuf); ++a) {
				if ((pbuf[a]>='0')&&(pbuf[a]<='9')) {
					b=strlen(regis.RGphone);
					regis.RGphone[b]=pbuf[a];
					regis.RGphone[b+1]=0;
					}
				}
			while(strlen(regis.RGphone)<10) {
				strcpy(pbuf,regis.RGphone);
				strcpy(regis.RGphone," ");
				strcat(regis.RGphone,pbuf);
				}

			printf("(%c%c%c) %c%c%c-%c%c%c%c\n",
				regis.RGphone[0],regis.RGphone[1],
				regis.RGphone[2],regis.RGphone[3],
				regis.RGphone[4],regis.RGphone[5],
				regis.RGphone[6],regis.RGphone[7],
				regis.RGphone[8],regis.RGphone[9]);
			}
		if (userdata->eternal==regis.RGeternal) break;
		}
	close(file);
	return(0);
	}
