/****************************************************************************/
/*                  YOUR SYSTEM CONFIGURATION                               */
/* Set all the values in this file appropriately BEFORE compiling any of the*/
/* C programs. If you are upgrading from an older version of Citadel/UX, it */
/* is vitally important that the #defines which are labelled "structure size*/
/* variables" are EXACTLY the same as they were in your old system,         */
/* otherwise your files will be munged beyond repair.                       */
/****************************************************************************/

/****************************************************************************/
/* Networking stuff
 * set NODENAME to your UUCP node name. Set PREVMSGS to the number of
 * records you want in the prevmsgs file, which keeps a record of recently
 * seen messages on all systems. This prevents messages from cycling
 * endlessly through the network. If you are not in a network, set PREVMSGS
 * to 2. If messages seem to be cycling endlessly through the network,
 * increase the value of PREVMSGS.
 */

#define NODENAME	"sysname"	/* Your system's uucp nodename      */
#define PREVMSGS	1000		/* Number of recs in prevmsgs file  */
/****************************************************************************/

#define BBSDIR		"/usr/bbs"
/* This is the directory Citadel will reside in. */

#define BBSUID		7
/* make an account called "bbs", "guest", or something to that effect which
 * shells directly to citadel. Place the userid of the account here. */

#define PWCRYPT		123
/* Set PWCRYPT to any value between 0 and 255 for password encryption. DO
 * NOT CHANGE IT ONCE IT IS SET or your users will all be locked out.
 */

#define CREATAIDE	0
/* If CREATAIDE is set to 1, anyone who creates a class 3 (passworded) or
 * class 4 (invitation-only) room automatically becomes the room-aide for
 * that room.
 */

#define SLEEPING	180
/* If the program is waiting for input more than SLEEPING number of seconds,
 * Citadel will print "Sleeping? Call again." and hang up. To disable the
 * feature, set SLEEPING to 0.
 */

#define INITAX		1
/* New users are assigned the access level of INITAX:
 * 0 = Marked for deletion
 * 1 = New User
 * 2 = Problem User
 * 3 = Local User
 * 4 = Network User
 * 5 = Preferred User
 * 6 = Aide
 * set this value to 4 for instant validation or 1 for validation required.
 */

#define REGISCALL	1
/* If a user has called REGISCALL times, he/she will be required to register.
 * Set this value to 0 to disable required registration.
 * NOTE: Citadel/UX still does not require user validation by the sysop.
 */

/*** STRUCTURE SIZE VARIABLES ***/
/* You may NOT change these six values once you set up your system.	    */
#define MAXROOMS	64		/* Number of rooms in system        */
#define MAILSLOTS	35		/* Number of mail slots             */
#define MSGSPERRM	150		/* Messages per room                */
#define MM_FILELEN	(2000000L)	/* Number of bytes in message file  */
#define CALLLOG		1000		/* Number of entries in call log    */
/* Do not set MAILSLOTS higher than MSGSPERRM 				    */
/*** END OF STRUCTURE SIZE VARIABLES ***/

#define TWITDETECT	1		/* 1=on, 0=off                      */
#define TWITROOM	"Trashcan"	/* Name of room to send problems to */
/* If TWITDETECT is set to 1, messages posted by those designated as
 * "problem users" will automatically be moved to TWITROOM regardless of
 * what room they were posted in.
 */
